/*
 * Copyright 2018 The Trickster Authors
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package lex

// Common Runes. Using these ensures unicode dopplegangers aren't accidentally used
const (
	RunePlus        = '+'
	RuneMinus       = '-'
	RuneAsterisk    = '*'
	RuneSlash       = '/'
	RunePercent     = '%'
	RuneComma       = ','
	RunePeriod      = '.'
	RuneExclamation = '!'
	RuneEqual       = '='
	RuneGreaterThan = '>'
	RuneLessThan    = '<'
	RuneSingleQuote = '\''
	RuneDoubleQuote = '"'
	RuneZero        = '0'
	RuneOne         = '1'
	RuneTwo         = '2'
	RuneThree       = '3'
	RuneFour        = '4'
	RuneFive        = '5'
	RuneSix         = '6'
	RuneSeven       = '7'
	RuneEight       = '8'
	RuneNine        = '9'
	RuneUnderscore  = '_'
	RuneLeftParen   = '('
	RuneRightParen  = ')'
	RuneSpace       = ' '
	RuneTab         = '\t'
	RuneCR          = '\r'
	RuneLF          = '\n'
	RuneA           = 'a'
	RuneB           = 'b'
	RuneC           = 'c'
	RuneD           = 'd'
	RuneE           = 'e'
	RuneF           = 'f'
	RuneG           = 'g'
	RuneH           = 'h'
	RuneI           = 'i'
	RuneJ           = 'j'
	RuneK           = 'k'
	RuneL           = 'l'
	RuneM           = 'm'
	RuneN           = 'n'
	RuneO           = 'o'
	RuneP           = 'p'
	RuneQ           = 'q'
	RuneR           = 'r'
	RuneS           = 's'
	RuneT           = 't'
	RuneU           = 'u'
	RuneV           = 'v'
	RuneW           = 'w'
	RuneX           = 'x'
	RuneY           = 'y'
	RuneZ           = 'z'
)
