/*
 * Copyright 2018 The Trickster Authors
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package dataset

// Code generated by github.com/tinylib/msgp DO NOT EDIT.

import (
	"github.com/tinylib/msgp/msgp"
)

// DecodeMsg implements msgp.Decodable
func (z *Result) DecodeMsg(dc *msgp.Reader) (err error) {
	var field []byte
	_ = field
	var zb0001 uint32
	zb0001, err = dc.ReadMapHeader()
	if err != nil {
		err = msgp.WrapError(err)
		return
	}
	for zb0001 > 0 {
		zb0001--
		field, err = dc.ReadMapKeyPtr()
		if err != nil {
			err = msgp.WrapError(err)
			return
		}
		switch msgp.UnsafeString(field) {
		case "statement_id":
			z.StatementID, err = dc.ReadInt()
			if err != nil {
				err = msgp.WrapError(err, "StatementID")
				return
			}
		case "error":
			z.Error, err = dc.ReadString()
			if err != nil {
				err = msgp.WrapError(err, "Error")
				return
			}
		case "series":
			var zb0002 uint32
			zb0002, err = dc.ReadArrayHeader()
			if err != nil {
				err = msgp.WrapError(err, "SeriesList")
				return
			}
			if cap(z.SeriesList) >= int(zb0002) {
				z.SeriesList = (z.SeriesList)[:zb0002]
			} else {
				z.SeriesList = make([]*Series, zb0002)
			}
			for za0001 := range z.SeriesList {
				if dc.IsNil() {
					err = dc.ReadNil()
					if err != nil {
						err = msgp.WrapError(err, "SeriesList", za0001)
						return
					}
					z.SeriesList[za0001] = nil
				} else {
					if z.SeriesList[za0001] == nil {
						z.SeriesList[za0001] = new(Series)
					}
					err = z.SeriesList[za0001].DecodeMsg(dc)
					if err != nil {
						err = msgp.WrapError(err, "SeriesList", za0001)
						return
					}
				}
			}
		default:
			err = dc.Skip()
			if err != nil {
				err = msgp.WrapError(err)
				return
			}
		}
	}
	return
}

// EncodeMsg implements msgp.Encodable
func (z *Result) EncodeMsg(en *msgp.Writer) (err error) {
	// map header, size 3
	// write "statement_id"
	err = en.Append(0x83, 0xac, 0x73, 0x74, 0x61, 0x74, 0x65, 0x6d, 0x65, 0x6e, 0x74, 0x5f, 0x69, 0x64)
	if err != nil {
		return
	}
	err = en.WriteInt(z.StatementID)
	if err != nil {
		err = msgp.WrapError(err, "StatementID")
		return
	}
	// write "error"
	err = en.Append(0xa5, 0x65, 0x72, 0x72, 0x6f, 0x72)
	if err != nil {
		return
	}
	err = en.WriteString(z.Error)
	if err != nil {
		err = msgp.WrapError(err, "Error")
		return
	}
	// write "series"
	err = en.Append(0xa6, 0x73, 0x65, 0x72, 0x69, 0x65, 0x73)
	if err != nil {
		return
	}
	err = en.WriteArrayHeader(uint32(len(z.SeriesList)))
	if err != nil {
		err = msgp.WrapError(err, "SeriesList")
		return
	}
	for za0001 := range z.SeriesList {
		if z.SeriesList[za0001] == nil {
			err = en.WriteNil()
			if err != nil {
				return
			}
		} else {
			err = z.SeriesList[za0001].EncodeMsg(en)
			if err != nil {
				err = msgp.WrapError(err, "SeriesList", za0001)
				return
			}
		}
	}
	return
}

// MarshalMsg implements msgp.Marshaler
func (z *Result) MarshalMsg(b []byte) (o []byte, err error) {
	o = msgp.Require(b, z.Msgsize())
	// map header, size 3
	// string "statement_id"
	o = append(o, 0x83, 0xac, 0x73, 0x74, 0x61, 0x74, 0x65, 0x6d, 0x65, 0x6e, 0x74, 0x5f, 0x69, 0x64)
	o = msgp.AppendInt(o, z.StatementID)
	// string "error"
	o = append(o, 0xa5, 0x65, 0x72, 0x72, 0x6f, 0x72)
	o = msgp.AppendString(o, z.Error)
	// string "series"
	o = append(o, 0xa6, 0x73, 0x65, 0x72, 0x69, 0x65, 0x73)
	o = msgp.AppendArrayHeader(o, uint32(len(z.SeriesList)))
	for za0001 := range z.SeriesList {
		if z.SeriesList[za0001] == nil {
			o = msgp.AppendNil(o)
		} else {
			o, err = z.SeriesList[za0001].MarshalMsg(o)
			if err != nil {
				err = msgp.WrapError(err, "SeriesList", za0001)
				return
			}
		}
	}
	return
}

// UnmarshalMsg implements msgp.Unmarshaler
func (z *Result) UnmarshalMsg(bts []byte) (o []byte, err error) {
	var field []byte
	_ = field
	var zb0001 uint32
	zb0001, bts, err = msgp.ReadMapHeaderBytes(bts)
	if err != nil {
		err = msgp.WrapError(err)
		return
	}
	for zb0001 > 0 {
		zb0001--
		field, bts, err = msgp.ReadMapKeyZC(bts)
		if err != nil {
			err = msgp.WrapError(err)
			return
		}
		switch msgp.UnsafeString(field) {
		case "statement_id":
			z.StatementID, bts, err = msgp.ReadIntBytes(bts)
			if err != nil {
				err = msgp.WrapError(err, "StatementID")
				return
			}
		case "error":
			z.Error, bts, err = msgp.ReadStringBytes(bts)
			if err != nil {
				err = msgp.WrapError(err, "Error")
				return
			}
		case "series":
			var zb0002 uint32
			zb0002, bts, err = msgp.ReadArrayHeaderBytes(bts)
			if err != nil {
				err = msgp.WrapError(err, "SeriesList")
				return
			}
			if cap(z.SeriesList) >= int(zb0002) {
				z.SeriesList = (z.SeriesList)[:zb0002]
			} else {
				z.SeriesList = make([]*Series, zb0002)
			}
			for za0001 := range z.SeriesList {
				if msgp.IsNil(bts) {
					bts, err = msgp.ReadNilBytes(bts)
					if err != nil {
						return
					}
					z.SeriesList[za0001] = nil
				} else {
					if z.SeriesList[za0001] == nil {
						z.SeriesList[za0001] = new(Series)
					}
					bts, err = z.SeriesList[za0001].UnmarshalMsg(bts)
					if err != nil {
						err = msgp.WrapError(err, "SeriesList", za0001)
						return
					}
				}
			}
		default:
			bts, err = msgp.Skip(bts)
			if err != nil {
				err = msgp.WrapError(err)
				return
			}
		}
	}
	o = bts
	return
}

// Msgsize returns an upper bound estimate of the number of bytes occupied by the serialized message
func (z *Result) Msgsize() (s int) {
	s = 1 + 13 + msgp.IntSize + 6 + msgp.StringPrefixSize + len(z.Error) + 7 + msgp.ArrayHeaderSize
	for za0001 := range z.SeriesList {
		if z.SeriesList[za0001] == nil {
			s += msgp.NilSize
		} else {
			s += z.SeriesList[za0001].Msgsize()
		}
	}
	return
}
